<template>
  <a-layout class="user-layout-container">
    <a-layout-header class="session-header">
      <div class="top">
        <div class="header">
          <img src="/logo_blue.svg?v2" class="logo" alt="logo">
        </div>
        <!-- <div class="desc">
          SuperEHR | Admin Portal
        </div> -->
        <h1>SuperEHR | Admin Portal</h1>
      </div>
    </a-layout-header>
    <a-layout-content>
      <div class="user-layout-login-wraper">
        <a-alert
          v-if="erroMessage"
          :message="erroMessage"
          type="error"
          show-icon
          style="margin-bottom: 24px;"
        />

        <a-spin :spinning="state.loginBtn">
          <a-form :form="form" class="user-layout-login">
            <a-form-item>
              <a-input
                v-decorator="[
                  'username',
                  {
                    rules: [
                      {
                        required: true,
                        whitespace: true,
                        message: 'Vui lòng nhập tài khoản'
                      }
                    ],
                    validateTrigger: 'change'
                  }
                ]"
                type="text"
                placeholder="Tài khoản"
              >
                <a-icon slot="prefix" :style="{ color: 'rgba(0,0,0,.25)' }" type="user" />
              </a-input>
            </a-form-item>

            <a-form-item>
              <a-input-password
                v-decorator="[
                  'password',
                  {
                    rules: [
                      {
                        required: true,
                        whitespace: true,
                        message: 'Vui lòng nhập mật khẩu của bạn'
                      }
                    ],
                    validateTrigger: 'blur'
                  }
                ]"
                type="password"
                autocomplete="false"
                placeholder="Mật khẩu"
              >
                <a-icon slot="prefix" :style="{ color: 'rgba(0,0,0,.25)' }" type="lock" />
              </a-input-password>
            </a-form-item>

            <a-form-item>
              <span @click="forgot" style="float: left;">
                <a class="forge-password">Quên mật khẩu ?</a>
              </span>
            </a-form-item>

            <a-form-item>
              <a-button
                :loading="state.loginBtn"
                :disabled="state.loginBtn"
                @click.stop.prevent="handleSubmit"
                type="primary"
                html-type="submit"
                class="login-button"
              >
                Đăng nhập
              </a-button>
            </a-form-item>
          </a-form>
        </a-spin>
      </div>
    </a-layout-content>
  </a-layout>
</template>

<script>
import { mapActions } from 'vuex'
import errorCodeMapping from '@/constants/errorCode'
export default {
  props: {
    signInConfig: {
      type: Object,
      default: () => {}
    }
  },
  data () {
    return {
      erroMessage: null,
      loginBtn: false,
      form: this.$form.createForm(this),
      state: {
        loginBtn: false
      }
    }
  },
  computed: {
    options () {
      const defaults = {
        username: '',
        isSignUpDisplayed: true
      }
      return Object.assign(defaults, this.signInConfig || {})
    }
  },
  methods: {
    ...mapActions('auth', ['login']),
    handleSubmit () {
      const {
        form: { validateFields },
        state
      } = this
      state.loginBtn = true
      const validateFieldsKey = ['username', 'password']
      validateFields(validateFieldsKey, { force: true }, async (err, values) => {
        if (!err) {
          this.erroMessage = null
          try {
            await this.login(values)
            this.$bus.$emit('authState', 'signedIn')
          } catch (error) {
            this.setError(error)
          } finally {
            state.loginBtn = false
          }
        }
      })
    },
    forgot () {
      this.$bus.$emit('authState', 'forgotPassword')
    },
    setError (err) {
      this.erroMessage = errorCodeMapping[err.errorCode] || 'Đã có lỗi phát sinh'
    }
  }
}
</script>

<style lang="less" scoped>
.user-layout-login-wraper {
  width: 360px;
  margin: auto;
  & > h3 {
    font-size: 16px;
    margin-bottom: 20px;
  }
}
.user-layout-login {
  label {
    font-size: 14px;
  }

  .getCaptcha {
    display: block;
    width: 100%;
    height: 40px;
  }

  .forge-password {
    font-size: 14px;
  }

  button.login-button {
    width: 100%;
  }

  .user-login-other {
    text-align: left;
    margin-top: 24px;
    line-height: 22px;

    .item-icon {
      font-size: 24px;
      color: rgba(0, 0, 0, 0.2);
      margin-left: 16px;
      vertical-align: middle;
      cursor: pointer;
      transition: color 0.3s;

      &:hover {
        color: #1890ff;
      }
    }

    .register {
      float: right;
    }
  }
}
.user-layout-container {
  .top {
    text-align: center;

    .header {
      height: 80px;
      line-height: 44px;
      .logo {
        height: 80px;
        vertical-align: top;
        margin-right: 0 !important;
        border-style: none;
      }

      .title {
        font-size: 28px;
        color: rgba(0, 0, 0, 0.85);
        font-family: Avenir, 'Helvetica Neue', Arial, Helvetica, sans-serif;
        font-weight: 600;
        position: relative;
        top: 2px;
      }
    }
    .desc {
      font-size: 14px;
      color: rgba(0, 0, 0, 0.45);
      margin-top: 12px;
      line-height: 20px;
      margin-bottom: 40px;
    }
  }
}
</style>
